import os
import re

from agent.common.config import Config
from agent.common.pylog import functionLog


class Fio:
    def __init__(self):
        pass

    @functionLog
    def _beforeParamSet(self):
        return True, "unnecessary"

    @functionLog
    def _afterParamSet(self):
        return True, "unnecessary"

    @functionLog
    def setParamAll(self, param_list):
        command = ""
        result = {}
        for param_name, param_info in param_list.items():
            command += " -{} {}".format(param_name, param_info["value"])
            result[param_name] = {
                "value": param_info["value"],
                "dtype": param_info["dtype"],
                "suc": True,
                "msg": ""
            }

        path = os.path.join(Config.FILES_PATH, "benchmark/fio/fio_IOPS_base.py")
        with open(path, "r", encoding='UTF-8') as f:
            data = f.read()
            data = re.sub(r'DEFAULT = "[a-zA-Z\d\-=\s]+"', 'DEFAULT = "{}"'.format(command), data)
        with open(path, "w", encoding='UTF-8') as f:
            f.write(data)

        return True, result

    @functionLog
    def getParamAll(self, param_list):
        param_dict = {
            "iodepth": 1,
            "bs": "512B",
            "numjobs": 8
        }
        result = {}
        for param_name, param_info in param_list.items():
            result[param_name] = {
                "value": param_dict[param_name], 
                "dtype": param_info["dtype"], 
                "suc": True, 
                "msg": ""
            }

        return True, result

    @functionLog
    def rollback(self):
        return True, "fio don't need rollback!"

    @functionLog
    def backup(self, _):
        return True, "fio don't need backup!"

